#################################################################################
#  MDULO CONTIFAX.PM V1.14														#
#	Mdulo com as funcionaliade de acesso ao MySql, Templates, Cookies e    	#
#	Validao																	#
#																				#
#  Sintax:																		#
#	use Contifax;																#
#	my $cf = Contifax->novo();													#
#																				#
#  Andr Rivotti Casimiro -- Contifax.com 2002									#
#  Criado em : 08-08-2002  ltima Actualizao : 12-09-2002						#
#################################################################################
package Contifax;
use HTML::Template;
use Carp;
use strict;

# Corrigido o bug do paramtro invladio na funcao mt  por Rivotti 12-09-2002
# Corrigido o bug do paramtro invladio na funcao mtl por Rivotti 05-09-2002
# Adicionado a funo template_limpar por Rivotti 04-09-2002
# Correco de erros de programao por Rivotti 02-09-2002
# Adicionado a funo template_executar por Rivotti 01-09-2002
# Alteraes nas funes template_ por Rivotti 01-09-2002

# ATALHOS PARA AS FUNCOES
sub ca  { cookie_actualizar(@_); }
sub cc  { cookie_contar_items(@_); }
sub ce  { cookie_escaziar(@_); }
sub cg  { cookie_guardar(@_); }
sub ci  { cookie_iniciar(@_); }
sub cl  { cookie_ler(@_); }
sub cr  { cookie_remover(@_); }
sub md  { mysql_desligar(@_); }
sub me  { mysql_executar(@_); }
sub ml  { mysql_ligar(@_); }
sub mr  { mysql_registo(@_); }
sub mrs { mysql_registos(@_); }
sub mt  { mysql_template(@_); }
sub mtc { mysql_template_combo(@_); }
sub mtl { mysql_template_loop(@_); }
sub mtt { mysql_testar(@_); }
sub ta  { template_adicionar(@_); }
sub te  { template_executar(@_); }
sub tim { template_imprimir(@_); }
sub tin { template_iniciar(@_); }
sub tl  { template_ler(@_); }
sub v   { validar(@_); }
sub vae { validar_adicionar_erros(@_); }
sub vc  { validar_comparar(@_); }
sub ve  { validar_erros(@_); }
sub vi  { validar_iniciar(@_); }
sub vp  { validar_pais(@_); }
sub vt  { validar_template(@_); }
sub vtc { validar_template_comparar(@_); }
sub vte { validar_template_erros(@_); }
sub vtv { validar_template_verificar(@_); }
sub vv  { validar_verificar(@_); }
#sub  { (@_); }

# COOKIE
# ^^^^^^

sub cookie_actualizar {
	my $self = shift;
	my %parametros = @_;
	foreach ( keys (%parametros) ) {
		$self->{'COOKIE'}->{$_} = $parametros{$_};
	}
	return 1;
}

sub cookie_contar_items {
	my $self = shift;
	my $count = keys( %{ $self->{'COOKIE'} } );
	return $count;
}

sub cookie_esvaziar {
	my $self = shift;
	$self->{'COOKIE'} = undef;
	return 1;
}

sub cookie_guardar {
	my ($self,$cookie,$expira,$dominio,$caminho,$seguro)  = @_;
	my $ck = new CGI->cookie(	
					-name	 => $cookie,
					-value	 => \%{ $self->{'COOKIE'} },
					-expires => $expira,
					-domain	 => $dominio,
					-path	 => $caminho,
					-secure  => $seguro
	);
	print "Set-Cookie: $ck\n";
	return 1;
}

sub cookie_iniciar {
	my ($self, $cookie) = @_;
	use CGI qw/:standard/;
	my %cookie = new CGI->cookie($cookie);
	$self->{'COOKIE'} = \%cookie || undef;
	return 1;
}

sub cookie_ler {
	my ($self,$item) = @_;
	return ( $item ? $self->{'COOKIE'}->{$item} : %{ $self->{'COOKIE'} } );
}

sub cookie_remover {
	my ($self,$item)  = @_;
	delete $self->{'COOKIE'}->{$item};
	return 1;
}


# MYSQL
# ^^^^^

# Metodo:	mysql_desligar
# Descrio:	Desliga a ligao ao Mysql
# Parametros:	-
# Retorna:	1/0	
sub mysql_desligar {
	my $self = shift;
	
	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	
	$self->{'MYSQL'}->disconnect || croak("Problemas ao desligar a ligao ao MySql!");
	
	return 1;
}

# Metodo:	mysql_executar
# Descrio:	Executa uma expresso de mysql dada
# Parametros:	Expressao e parametros
# Retorna:	1/0
sub mysql_executar {
	my ($self,$query, @parametros) = @_;
	
	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;
	
	$self->{'MYSQL'}->do($query, undef, @parametros )
		|| croak("Problemas ao executar a query: $query!");

	return 1;
}

# Metodo:	mysql_ligar
# Descrio:	Faz a ligao ao Mysql
# Parametros:	Base de Dados, utilizador e chave
# Retorna:	1/0
sub mysql_ligar {
	my ($self, @param) = @_;
	
	croak("Base de Dados por definir na ligao ao MySql!") if !$param[0];
	croak("Utilizador por definir na ligao ao MySql!") if !$param[1];
	#carp("Chave por definir na ligao ao MySql!") if !$param[2];

	use DBI;	
	$self->{'MYSQL'} = DBI->connect(
					'DBI:mysql:'.$param[0],
					$param[1],
					$param[2]
	) || croak("Problemas a aceder ao MySql!");
	
	return 1;
}

# Metodo:	mysql_registos
# Descrio:	Faz a contagem do nmero de registos de uma expresso dada
# Parametros:	Expresso e parmetros
# Retorna:	Numero de registos
sub mysql_registos {
	my ($self, $tabela, $parametro, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Tabela de MySql por definir!") if !$tabela;

	my $count = undef;
	my $query = qq/SELECT COUNT(*) FROM $tabela/;
	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	($count) = $resultado->fetchrow_array;

	push @{$self->{'PARAMS'}}, ( $parametro => $count ) if $parametro;

	return $count;
}

# Metodo:	mysql_registo
# Descrio:	Executa uma espresso de MySql
# Parametros:	Expresso e parmetros
# Retorna:	Array com o ltimo registo do resultado
sub mysql_registo {
	my ($self,$query, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;
	
	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	return $resultado->fetchrow_array;
}

# Metodo:	mysql_template
# Descrio:	Executa uma expresso dada e adicionao ao parametros do template
# Parametros:	Expresso, 1/0, funco, e parametros
# Retorna:	Array com parametros para o Template 
sub mysql_template {
	my ($self, $query, $parametro, $funcao, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;

	my @lista = ();
	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	if ( $funcao ) {
		while ( my @array = $resultado->fetchrow_array) {
			&$funcao(@array);
		}
	} else {
		while ( my $hash = $resultado->fetchrow_hashref) {
			foreach (keys %$hash) {
				my $ref = $_;
				my $valor = $hash->{$ref};
				push @lista, ( $ref => $valor );
			}
		}	
	}
	
	push @{$self->{'PARAMS'}}, ( @lista ) if $parametro;
	
	return ( $funcao ? 1 : @lista );
}

# Metodo:	mysql_template_combo
# Descrio:	Executa uma expresso dada e adicionao ao parametros a uma combo no template
# Parametros:	Expresso, parametro do template, opo selecionada na combo, e parametros
# Retorna:	Array com parametros para o Template 
sub mysql_template_combo {
	my ($self, $query, $parametro, $seleccao, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;
	croak("Parametro do Template por definir!") if !$parametro;

	my @lista = ();
	
	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	while ( my @array = $resultado->fetchrow_array) {
		my $flag = 0;
		$flag = 1 if $array[0] eq $seleccao;
		push @lista, {
				REF  => $array[0],
				NOME =>	$array[1],
				SEL  => $flag
		};
	}
	
	push @{$self->{'PARAMS'}}, ( $parametro => \@lista ) if $parametro;
	
	return @lista;
}

# Metodo:	mysql_template_loop
# Descrio:	Executa uma expresso dada e adicionao ao parametros do template
# Parametros:	Expresso, parametro do template, funco, e parametros
# Retorna:	Array com parametros para o Template 
sub mysql_template_loop {
	my ($self, $query, $parametro, $funcao, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;
	
	my @lista = ();
	
	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	if ( $funcao ) {
		while ( my @array = $resultado->fetchrow_array) {
			push @lista, &$funcao(@array);
		}
	} else {
		while ( my $hash = $resultado->fetchrow_hashref) {
			my $hash_temp = {};
			foreach (keys %$hash) {
				my $ref = $_;
				my $valor = $hash->{$ref};
				$hash_temp->{$ref} = $valor;
			}
			push @lista, $hash_temp;
		}	
	}
	
	push @{$self->{'PARAMS'}}, ( $parametro => \@lista ) if $parametro;

	return @lista;
}

# Metodo:	mysql_testar
# Descrio:	Verifica se a expresso dada  vlida ou retorna valores
# Parametros:	Expresso e parmetros
# Retorna:	1/0
sub mysql_testar {
	my ($self,$query, @parametros) = @_;

	croak("Ligao ao MySql por definir!") if !$self->{'MYSQL'};
	croak("Expresso de MySql por definir!") if !$query;

	my $resultado = $self->{'MYSQL'}->prepare($query)
		|| croak("Problemas ao iniciar a query: $query!");
	$resultado->execute(@parametros)
		|| croak("Problemas ao executar a query: $query!");
	return ( my $hash = $resultado->fetchrow_hashref ? 1 : 0 );
}


# FUNES GERAIS
# ^^^^^^^ ^^^^^^

sub novo {
	my $class = shift;
	my $self = {};
	return bless ($self, $class);
}


# TEMPLATE
# ^^^^^^^^

sub template_adicionar {
	my ( $self, @param ) = @_;
	push @{$self->{'PARAMS'}}, ( @param );
	return 1;	
}

sub template_executar {
    my $self = shift;
    my @params = $self->{'TEMPLATE'}->param();
    for my $param (@params) {      
       if ($param =~ /^__execute_(.*)__$/) {
         $self->{'TEMPLATE'}->param($param, do($1));
       }
    }	
}

sub template_imprimir {
	my ($self,$ficheiro,$dobp,$lcv,$gv) = @_;
	if ($ficheiro) {
		$dobp = 0 if !$dobp;
		$lcv = 1 if !$lcv;
		$gv = 0 if !$gv;
		template_iniciar($self,$ficheiro,$dobp,$lcv,$gv) if $ficheiro;
	}
	template_executar($self);
	$self->{'TEMPLATE'}->param( @{$self->{'PARAMS'}} );
	print "Content-type: text/html\n\n";
	print template_limpar($self->{'TEMPLATE'}->output);
	return 1;
}

sub template_iniciar {
	my ($self,$ficheiro,$dobp,$lcv,$gv) = @_;
	$dobp = 0 if !$dobp;
	$lcv = 1 if !$lcv;
	$gv = 0 if !$gv;
	$self->{'TEMPLATE'} = HTML::Template->new(	
		filename => "$ficheiro",
		die_on_bad_params => $dobp,
		loop_context_vars => $lcv,
		global_vars => $gv
	) || die;
	return $self->{'TEMPLATE'};
}

sub template_ler {
	my ($self,$ficheiro,$dobp,$lcv,$gv) = @_;
	if ($ficheiro) {
		$dobp = 0 if !$dobp;
		$lcv = 1 if !$lcv;
		$gv = 0 if !$gv;
		template_iniciar($self,$ficheiro,$dobp,$lcv,$gv) if $ficheiro;
	}
	template_executar($self);
	$self->{'TEMPLATE'}->param( @{$self->{'PARAMS'}} );
	return template_limpar($self->{'TEMPLATE'}->output);
}

sub template_limpar {
	my $template = shift;
	$template =~ s/<!--[^-]+-->//g;
	$template =~ s/\n{2,}//g;
	$template =~ s/ {2,}//g;
	$template =~ s/\t*//g;
	$template =~ s/\s*<\/td>/<\/td>/ig;
	$template =~ s/<td>\s*/<td>/ig;
	$template =~ s/(..\/)*web//ig;
	return $template;
}


# VALIDAO
# ^^^^^^^^^

my %expr_regular = (
	GERAL	  => {
		CHAVE	     => qr/^.{4,12}$/,
		C_POSTAL     => qr/^[-0-9]+$/,
		CONTRIBUINTE => qr/^[-0-9]+$/,
		FAX	     => qr/^[-0-9]*$/,
		LOCALIDADE   => qr/^[-a-z .,']+$/i,
		MAIL	     => qr/^[a-z0-9_-]+(?:\.[a-z0-9_-]+)*\@[a-z0-9_-]+(?:\.[a-z0-9_-]+)*\.[a-z]{2,4}$/,
		MORADA       => qr/^[-0-9a-z .,']+$/i,
		NOME         => qr/^[-a-z. ']+$/i,
		TELEFONE     => qr/^[-0-9]*$/,
		TELEMOVEL    => qr/^[-0-9]*$/
	},
	PORTUGAL  => {
		C_POSTAL     => qr/^[1-9]{1}[0-9]{3}(?:-[0-9]{3})?$/,
		CONTRIBUINTE => qr/^[0-9]{9}$/,
		FAX	     => qr/^(351)?2[1-9][0-9]{7}$/,
		TELEFONE     => qr/^(351)?2[1-9][0-9]{7}$/,
		TELEMOVEL    => qr/^(351)?9(1|3|6)[0-9]{7}$/	
	}
);

sub validar {
	my ( $self, $tipo, $campo ) = @_;
	my $regexp = $expr_regular{$self->{'VALIDAR_PAIS'}}{$tipo};
	$regexp = $expr_regular{"GERAL"}{$tipo} if !$regexp;
	return ( $campo =~ /$regexp/ ? 1 : 0 );
}

sub validar_adicionar_erros {
	my $self = shift;
	my %erros = @_;
	foreach ( keys (%erros) ) {
		push @{$self->{'VALIDAR_ERROS'}}, ( $_ => $erros{$_} );
	}
	return 1;
}

sub validar_erros {
	my $self = shift;
	return ( $self->{'VALIDAR_ERROS'} ? @{ $self->{'VALIDAR_ERROS'} } : 0 );
}

sub validar_comparar {
	my ( $self, $campo1, $campo2 ) = @_;
	return ( $campo1 eq $campo2 ? 1 : 0 );
}

sub validar_iniciar {
	my ( $self, $pais ) = @_;
	$self->{'VALIDAR_PAIS'} = $pais;
	return 1;
}

sub validar_pais {
	my ( $self, $pais ) = @_;
	$self->{'VALIDAR_PAIS'} = $pais;
	return 1;
}

sub validar_template {
	my ( $self, $tipo, $campo, @erro ) = @_;
	my $regexp = $expr_regular{$self->{'VALIDAR_PAIS'}}{$tipo};
	$regexp = $expr_regular{"GERAL"}{$tipo} if !$regexp;
	if ( $campo !~ /$regexp/ ) {
		push @{$self->{'VALIDAR_ERROS'}}, ( $erro[0] => $erro[1] );
		return 0;
	} else {
		return 1;
	}
}

sub validar_template_comparar {
	my ( $self, $campo1, $campo2, @erro ) = @_;
	if ( $campo1 ne $campo2  ) {
		push @{$self->{'VALIDAR_ERROS'}}, ( $erro[0] => $erro[1] );
		return 0;
	} else {
		return 1;
	}
}

sub validar_template_erros {
	my $self = shift;
	if ( $self->{'VALIDAR_ERROS'} ) {
		push @{$self->{'PARAMS'}}, ( @{$self->{'VALIDAR_ERROS'}} );
		return 1;
	} else {
		return 0;	
	}
}

sub validar_template_verificar {
	my ( $self, $campo, @erro ) = @_;
	if ( !$campo ) {
		push @{$self->{'VALIDAR_ERROS'}}, ( $erro[0] => $erro[1] );
		return 0;
	} else {
		return 1;
	}

}

sub validar_verificar {
	my ( $self, $campo ) = @_;
	return ( $campo ? 1 : 0 );
}

# Metodo:	
# Descrio:	
# Parametros:	
# Retorna:	
#sub {
#	
#}
1;