#################################################################################
#  MOHAA.pm V1.0																#
#  Andr Rivotti Casimiro -- Contifax.com 2002									#
#  Creation : 25-10-2002  Last Update : 02-12-2002								#
#################################################################################
package Rcon::MOHAA;
use Rcon;
use Carp;
use strict;

my $Rcon;

# Erros messages. (Why do I allways have to do this?)
my %ErrorMessages = (
	1 => "Script ended without calling close method!"
);

sub changemap {
	my ($self, $map) = @_;
	$Rcon->sendcommand("map $map");
}

sub clientkick {
	my ($self, $client_id) = @_;
	$Rcon->sendcommand("clientkick $client_id");
	return 1;
}

sub close {
	my $self = shift;
	$Rcon->close();
	$Rcon = undef;
}

sub dumpuser {
	my ($self, $client_name) = @_;
	my $response = $Rcon->sendcommand('dumpuser "'. $client_name .'"');
	if ( wantarray ) {
		my %values = ();
		foreach( split(/\n/, $response) ) {
			if ( /^(\S+)\s+:\s+(.+)$/ ) {
				$values{$1} = $2;
			}
		}
		return %values;
	} else {
		return $response;
	}
}

sub getcvars {
	my $self = shift;
	my @cvars = @_;
	my @values = ();
	foreach ( @cvars ) {
		my $response = $Rcon->sendcommand("$_");
		if ( $response =~ m/^\"$_\"\sis:\"(.*)"\sdefault:\".*"$/ ) {
			push @values, $1;		
		}
	}
	return @values;
}

sub getcvarsdefault {
	my $self = shift;
	my @cvars = @_;
	my @values = ();
	foreach ( @cvars ) {
		my $response = $Rcon->sendcommand("$_");
		if ( $response =~ m/^\"$_\"\sis:\".*"\sdefault:\"(.*)"$/ ) {
			push @values, $1;		
		}
	}
	return @values;
}

sub getplayers {
	my $self = shift;
	my $response = $Rcon->sendcommand("status");
	if ( wantarray ) {
		my @values = ();
		foreach( split(/\n/, $response) ) {
			if ( /^
					\s*       # somtimes there are spaces before each line
					(\d+)\s+  # Client number
					(\d+)\s+  # Score
					(\d+)\s+  # Ping
					(.+)\s+   # Player Name
					(\d+)\s+  # Lastmsg
					(\S+)\s+  # Addres
					(\d+)\s+  # Qport
					(\d+)     # Rate
				$/x ) {
				push @values, {
					num     => $1,
					score   => $2,
					ping    => $3,
					name    => $4,
					lastmsg => $5,
					address => $6,
					qport   => $7,
					rate    => $8
				};
			}
		}
		return @values;
	} else {
		return $response;
	}
}

sub getserverinfo {
	my $self = shift;
	my $response = $Rcon->sendcommand("serverinfo");
	if ( wantarray ) {
		my %values = ();
		foreach( split(/\n/, $response) ) {
			if ( /^(\S+)\s+:\s+(.+)$/ ) {
				$values{$1} = $2;
			}
		}
		return %values;
	} else {
		return $response;
	}
}

sub kick {
	my ($self, $client_name) = @_;
	$Rcon->sendcommand('kick "'. $client_name .'"');
	return 1;
}

sub new {
	my $invoncant = shift;
	my $class     = ref($invoncant) || $invoncant;
	my $self      = { Game => "MOHAA", @_ };
		
	$Rcon = Rcon->new( Game => "MOHAA", @_ );
	
	bless($self,$class);
	return $self;
}

sub disconnect {
	my $self = shift;
	$Rcon->sendcommand("quit");
	return 1;
}

sub restartmap {
	my $self = shift;
	$Rcon->sendcommand("restart");
	return 1;
}

sub say {
	my ($self, $msg) = @_;
	$Rcon->sendcommand('say "'. $msg .'"');
	return 1;
}

sub setcvars {
	my $self = shift;
	my %cvars = @_;
	#my $command = undef;
	
	foreach ( keys (%cvars) ) {
		$Rcon->sendcommand('set '.$_.' "'.$cvars{$_}.'"');
		#$command .= 'set '.$_.' "'.$cvars{$_}.'";';
	}
	
	#$command =~ s/;$//ig;
	#$Rcon->sendcommand($command);
	return 1;
}

sub DESTROY {
	carp($ErrorMessages{1}) if $Rcon;
}

1;

__END__